package geniusweb.simplerunner;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;

import org.junit.Before;
import org.junit.Test;

import com.fasterxml.jackson.databind.ObjectMapper;

import geniusweb.protocol.session.SessionSettings;
import geniusweb.simplerunner.ClassPathConnectionFactory;
import geniusweb.simplerunner.NegoRunner;
import tudelft.utilities.logging.ReportToLogger;
import tudelft.utilities.logging.Reporter;

/**
 * E2E test doing a full real run of a session with real agents and protocol.
 * NOTICE This will exercise a full system to errors here may point far outside
 * this module.
 */
public class SessionRunnerE2ETest {
	private static final String SESSION_SETTINGS = "src/test/resources/settings.json";
	private final ObjectMapper jackson = new ObjectMapper();
	private NegoRunner runner;
	private Reporter logger = new ReportToLogger("test");

	@Before
	public void before() throws IOException {
		String serialized = new String(
				Files.readAllBytes(Paths.get(SESSION_SETTINGS)),
				StandardCharsets.UTF_8);
		SessionSettings settings = jackson.readValue(serialized,
				SessionSettings.class);

		runner = new NegoRunner(settings, new ClassPathConnectionFactory(),
				logger);

	}

	@Test
	public void smokeTest() throws IOException {
	}

	@Test
	public void runTest() throws IOException {
		runner.run();
	}

	@Test
	public void runTestMainFunction() throws IOException {
		NegoRunner.main(new String[] { SESSION_SETTINGS });
	}
}
